<?php
/*
 * Plugin Name: Infinite Uploads Gravity Forms Support
 * Version: 1.0
 * Description: Infinite Plugins Gravity Forms Addon
 * Author: Infinite Uploads
 * Requires Plugins: gravityforms, infinite-uploads
 * Author URI: https://infiniteuploads.com/
 * Tested up to: 6.6
 * Requires PHP: 7.4
 * Text Domain: gravity-forms-iu-addon
 */

/**
 * Show Infinite Uploads Path on entry details page.
 */
function clt_show_iu_path_entry_detail( $display_value, $field, $lead, $form ) {
	if ( $field->type == 'fileupload' ) {
		$display_value = '<ul>';
		$value = RGFormsModel::get_lead_field_value( $lead, $field );
		$decoded = json_decode( $value, true );
		if ( json_last_error() === JSON_ERROR_NONE && is_array( $decoded ) ) {
			foreach ( $decoded as $single_file ) {
				$filename  = wp_basename( $single_file );
				$display_value .= '<li><a href=' . $single_file . ' target="_new">' . $filename . '</a></li>';
			}
		} else {
			$filename  = wp_basename( $value );
			$display_value .= '<li><a href=' . $value . ' target="_new">' . $filename . '</a></li>';
		}
		$display_value .= '<ul>';
	}
	return $display_value;
}
add_filter( 'gform_entry_field_value', 'clt_show_iu_path_entry_detail', 99, 4 );

/**
 * Show Infinite Uploads Path on entry list page.
 */
function clt_gforms_entry_list_path_fix( $url ) {
	if ( isset( $_GET['page'] ) && $_GET['page'] == 'gf_entries' ) {
		$parse_url = parse_url( $url );
		parse_str( $parse_url['query'], $query );
		$form_id = $query['form-id'];
		$path      = GF_Field_FileUpload::get_upload_root_info( $form_id );
		$filename  = wp_basename( $query['gf-download'] );
		$iu_url = $path['url'];
		$full_iu_path = $iu_url . $filename;
		return $full_iu_path;
	} else {
		return $url;
	}
}
add_filter( 'gform_secure_file_download_url', 'clt_gforms_entry_list_path_fix' );